#!/usr/bin/perl
require "config.pl";

if ($ENV{"REQUEST_METHOD"} eq 'GET') { $buffer = $ENV{'QUERY_STRING'}; }
else { read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'}); }
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
  ($name, $value) = split(/=/, $pair);
  $value =~ tr/+/ /;
  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  $FORM{$name} = $value;
}

if ($FORM{'action'}) {
 $action=$FORM{'action'};
}
else {
 $action = 'show';
}

print "Content-type: text/html\n\n";

if ($action eq 'show') { &show; }
elsif ($action eq 'admin') { &admin; }
elsif ($action eq 'gotome') { &gotome; }
elsif ($action eq 'delme') { &delme; }
elsif ($action eq 'pere') { &pere; }
else { &plus; }
exit;

sub checkpassword {
 if ($FORM{'password'} eq "") {
  &html;
  print ",    .<br>\n";
  print "<a href=\"$addname\">  \"\"        ...</a></body></html>";
  &htmlend;
  exit;
 }
 elsif ($FORM{'password'} ne $password) {
  &html;
  print ",   <b>$FORM{'password'}</b> .";
  print "<br><a href=\"$addname\">  \"\"        ...</a></body></html>";
  &htmlend;
  exit;
 }
}

sub show2 {
 @months = ('','','','','','','','','','','','');
 open(DATA, "$datafolder/$basename2");
 @data = <DATA>;
 close(DATA);
 &addform;
 print "<center><b> :</b></center>";
 print "<table width=\"100%\" border=0>\n";
 print "<tr><td><b></b></td><td><b></b></td><td><b></b></td><td><b></b></td><td><b></b></td></tr>\n";
 foreach $line(@data) {
  chomp($line);
  ($name1, $day1, $mon1, $year1, $comment1) = split(/\|/, $line);
  print "<tr><td>$name1</td><td>$day1</td><td>$mon1</td><td>$year1</td><td>$comment1</td></tr>\n";
 }
 print "</table><hr width=\"100%\" size=1 align=center noshade><br>\n";
 $all=$#data+1;

 open(LAST, "$datafolder/time.bd");
 @linen = <LAST>;
 close(LAST);
 foreach $strn(@linen) {
  ($dayn, $monn, $yearn, $hourn, $minn) = split(/\|/, $strn);
  if ($minn<10) { $minn = "0".$minn; }
  print "<i>  : $dayn $months[$monn] $yearn ., $hourn:$minn</i><br>";
  break;
 }
 print "<i> : $all</i><br>";
}

sub show {
 &html;
 &show2;
 &htmlend;
 exit;
}

sub printdate {
 print <<DATE1;
    (*): 
<select name=day size=1>
<option selected value=""></option>
<option value=01>01</option>
<option value=02>02</option>
<option value=03>03</option>
<option value=04>04</option>
<option value=05>05</option>
<option value=06>06</option>
<option value=07>07</option>
<option value=08>08</option>
<option value=09>09</option>
<option value=10>10</option>
<option value=11>11</option>
<option value=12>12</option>
<option value=13>13</option>
<option value=14>14</option>
<option value=15>15</option>
<option value=16>16</option>
<option value=17>17</option>
<option value=18>18</option>
<option value=19>19</option>
<option value=20>20</option>
<option value=21>21</option>
<option value=22>22</option>
<option value=23>23</option>
<option value=24>24</option>
<option value=25>25</option>
<option value=26>26</option>
<option value=27>27</option>
<option value=28>28</option>
<option value=29>29</option>
<option value=30>30</option>
<option value=31>31</option>
</select>
    (*): 
<select name=mon size=1>
<option selected value=""></option>
<option value=01></option>
<option value=02></option>
<option value=03></option>
<option value=04></option>
<option value=05></option>
<option value=06></option>
<option value=07></option>
<option value=08></option>
<option value=09></option>
<option value=10></option>
<option value=11></option>
<option value=12></option>
</select>
   : <select name=year size=1>
<option selected value=""></option>  
DATE1
 ($sec,$min,$hour,$mday,$mon1,$thisyear,$wday) = localtime(time); 
 if ($thisyear<1900) { $thisyear+=1900; }
 for ($i=$thisyear; $i>=1900; $i-=1) {
  print "<option value=$i>$i</option>\n";
 }
 print "</select>";
}

sub filter0 { #    
 $name=@_[0];
 $name =~ s/\|/\!/g;
 $name =~ s/\"/\'/g;
 $name =~ s/\</\[/g;
 $name =~ s/\>/\]/g;
 return $name;
}

sub filter1 { #   HTML
 $name=@_[0];
 $name =~ s/\|/!/g;
 $name =~ s/\<\/body\>//g;
 $name =~ s/\<\/html\>//g;
 return $name;
}

sub filter { # 
 $name=@_[0];
 $name =~ s/\&/\&amp\;/g;
 $name =~ s/\"/\&quot\;/g;
 $name =~ s/\</\&lt\;/g;
 $name =~ s/\>/\&gt\;/g;
 return $name;
}

sub goto2 {
 $number=$FORM{'number'};
 print "<br>[<a href=\"$myname\">  </a>]";
 &addform;
 open(DATA, "$datafolder/$basename2");
 @data = <DATA>;
 close(DATA);
 if (@data) {
  print "<table width=\"100%\" border=0>\n";
  print "<tr><td><b> <br></b></td><td><b></b></td><td><b></b></td><td><b></b></td><td><b></b></td><td><b></b></td><td><b></b></td></tr>\n";
  $number=0;
  foreach $line(@data) {
   chomp($line);
   ($name1, $day1, $mon1, $year1, $comment1) = split(/\|/, $line);
   $comment0=&filter ($comment1);
   print "<tr><td><form method=post><input type=hidden name=action value=pere><input type=hidden name=number value=$number><input type=hidden name=name value=\"$name1\"><input type=hidden name=day value=$day1><input type=hidden name=mon value=$mon1><input type=hidden name=year value=$year1><input type=hidden name=comment value=\"$comment0\"><input type=submit class=button name=b1 value=K></form></td>\n";
   print "<td><form method=get><input type=hidden name=action value=delme><input type=hidden name=number value=$number><input type=submit class=button name=d2 value=Del></form></td>\n";
   print "<td>$name1</td><td>$day1</td><td>$mon1</td><td>$year1</td><td>$comment0</td></tr>\n";
   $number+=1;
  } 
  print "</table>";
 }
 else {
  print "<br>   $basename2    .";
 }
 open(LAST, ">$datafolder/time.bd");
 ($secn,$minn,$hourn,$dayn,$monn,$yearn,$wdayn) = localtime(time); 
 if ($yearn<1900) { $yearn+=1900; }
 print LAST "$dayn|$monn|$yearn|$hourn|$minn";
 close(LAST);
}

sub delme2 {
 $number=$FORM{'number'};
 open(DATA, "$datafolder/$basename2");
 @data = <DATA>;
 close(DATA);
 if (@data) {
  open(DATA, ">$datafolder/$basename2");
  $count=0;
  foreach $line(@data) {
   chomp($line);
   if ($count!=$number) {
    print DATA "$line\n";
   }
   $count+=1;
  }
  close (DATA);
 }
}

sub delme {
 &html;
 &delme2;
 &goto2;
 &htmlend;
 exit;
}

sub pere {
 &html;
 $name=$FORM{'name'};
 $day=$FORM{'day'};
 $mon=$FORM{'mon'};
 $year=$FORM{'year'};
 $comment=$FORM{'comment'};
 $added=0;
 open(DATA, "$datafolder/$basename");
 @data = <DATA>;
 close(DATA);
 open(DATA, ">$datafolder/$basename");
 foreach $line(@data) {
  chomp $line;
  ($name1, $day1, $mon1, $year1, $comment1) = split(/\|/, $line);
  if ($added ==0) {
   if ($mon <= $mon1) {
    if ($day <= $day1) {
     if ( ($name lt $name1) or
          (($mon==$mon1) and ($day<$day1)) ) {
      $newline=join "\|",$name,$day,$mon,$year,$comment;
      print DATA "$newline\n";
      $added=1;
     }
    }
   }
  }
  print DATA "$line\n";
 }
 if ($added==0) {
  $newline=join "\|",$name,$day,$mon,$year,$comment;
  print DATA "$newline\n";
 }
 close (DATA);
 &delme2;
 print "<p>     $basename</p>";
 &goto2;
 &htmlend;
 exit;
}

sub gotome {
 &checkpassword; 
 &html;
 &goto2;
 &htmlend;
 exit;
}

sub admin {
 &html;
 print <<ADMINFORM;
  <br>     :
  <form method=get>
   <input type=hidden name=action value=gotome>
   <input type=password name=password size=10 maxlength=10>
   <input type=submit class=button value="">
  </form>
ADMINFORM
 &htmlend;
 exit;
}

sub plus {
 &html;
 $name=$FORM{'name'};
 $code=$FORM{'code'};
 $code2=$FORM{'code2'};
 $day=$FORM{'day'};
 $mon=$FORM{'mon'};
 $year=$FORM{'year'};
 $comment=$FORM{'comment'};
 $name0=&filter0 ($name);
 $comment0=&filter1 ($comment);
 $bad=0;
 if ("$code" ne "$code2") {
  print "<p>     .</p>";
  $bad=1;
 }
 if ("$name0" eq "") {
  print "<p>  -        !</p>";
  $bad=1;
 }
 if ($day eq "") {
  print "<p>  -    !</p>";
  $bad=1;
 }
 if ($mon eq "") {
  print "<p>  -    !</p>";
  $bad=1;
 }
 if ($bad==0) {
  open(DATA, ">>$datafolder/$basename2");
  print DATA "$name0\|$day\|$mon\|$year\|$comment0\n";
  close (DATA);
  print "<p> </p>";
 }
 &show2;
 &htmlend;
 exit;
}

sub getcode {
 srand (time); 
 my $symbols="123456789abcdefghijklmnopqrstuvwxyz"; 
 my $code = "";
 my $len=length($symbols);
 for ($i=0; $i<4; $i++) {
  $code.=substr($symbols,int(rand($len)),1);
 } 
 return $code;
}

sub tagcode {
 my $code=@_[0];
 my @tags = ( "sup","sub","big","small","u","b","i" );
 my $str="<font size=3>";
 my $t=0;
 for ($i=0; $i<4; $i++) {
  $t=int(rand($#tags));
  $str.= '<'.$tags[$t].'>'.substr($code,$i,1).'</'.$tags[$t].'>';
 }
 $str.="</font>";
 return $str;
}

sub addform {
 my $code = &getcode;
 my $code2= &tagcode ($code);
 print "<br>   (* -  ;      !)";
 print "<form method=post>";
 print "<input type=hidden name=action value=plus>";
 print "<input type=hidden name=code value=\"$code\">";
 print " (*): <input type=text name=name size=40 maxlength=96><br>";
 &printdate;
 print "<br>: <input type=text size=40 maxlength=255 name=comment><br>";
 print " ? -   - <font color=red>$code2</font> <input type=text size=4 name=code2 value=\"\" maxlength=4><br>";
 print "<small><i>   <b></b>   <font color=red>|</font> (  <font color=red>!</font>).<br>";
 print "   <b></b>   <font color=red>&lt;</font>, <font color=red>&gt;</font>, <font color=red>&quot;</font><br>";
 print " <b></b>    .     \"\"       .</font></i></small>";
 print "<br><input type=submit class=button value=\"\"> <input type=reset class=button value=\"\"></form>";
 print "<small>[<a href=\"$myname\">&nbsp;&nbsp;&nbsp;</a>] ";
 print "[<a href=\"$addname?action=admin\"> ( )</a>]</small>";
}

sub html {
 open (HEADER,"$filehdr2");
 while (<HEADER>) {
  print "$_";
 }
 close (HEADER); 
}

sub htmlend {
 open (SOF,"$fileend2");
 while (<SOF>) {
  print "$_";
 }
 close (SOF); 
}		
