#!/usr/bin/perl
require "config.pl";

if ($ENV{"REQUEST_METHOD"} eq 'GET') { $buffer = $ENV{'QUERY_STRING'}; }
else { read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'}); }
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
  ($name, $value) = split(/=/, $pair);
  $value =~ tr/+/ /;
  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  $FORM{$name} = $value;
}

if ($FORM{'action'}) {
 $action=$FORM{'action'};
}
else {
 $action = 'search';
}

print "Content-type: text/html\n\n";

if ($action eq 'show') { &show; }
elsif ($action eq 'admin') { &admin; }
elsif ($action eq 'add') { &add; }
elsif ($action eq 'plus') { &plus; }
elsif ($action eq 'delme') { &delme; }
else { &search; }
exit;

sub checkpassword {
 if ($FORM{'password'} eq "") {
  &html;
  print ",    .<br>\n";
  print "<a href=\"$myname\">  \"\"        ...</a></body></html>";
  &htmlend;
  exit;
 }
 elsif ($FORM{'password'} ne $password) {
  &html;
  print ",   <b>$FORM{'password'}</b> .";
  print "<br><a href=\"$myname\">  \"\"        ...</a></body></html>";
  &htmlend;
  exit;
 }
}

sub show {
 &html;
 $name=$FORM{'name'};
 $day=$FORM{'day'};
 $mon=$FORM{'mon'};
 $year=$FORM{'year'};
 $comment=$FORM{'comment'};
 $mode=$FORM{'mode'};
 $reg=$FORM{'reg'};
 if ($reg ne 'yes') {
  $name =~ tr/([a-z-])/([A-Z-])/;
  $comment =~ tr/([a-z-])/([A-Z-])/;
 }
 open(DATA, "$datafolder/$basename");
 @data = <DATA>;
 close(DATA);
 if (@data) {
  &searchform;
  $lines=0;
  $fields=0;
  if ($name ne "") { $fields+=1; }
  if ($day ne "") { $fields+=1; }
  if ($mon ne "") { $fields+=1; }
  if ($year ne "") { $fields+=1; }
  if ($comment ne "") { $fields+=1; }
  if ($fields==0) {
   print "<center><b>   !</b></center>";
  }
  else {
   print "<center><b> </b></center>";
   print "<table width=\"100%\" border=0>\n";
   print "<tr><td><b></b></td><td><b></b></td><td><b></b></td><td><b></b></td><td><b></b></td></tr>\n";
   foreach $line(@data) {
    chomp($line);
    $found=0;
    ($name1, $day1, $mon1, $year1, $comment1) = split(/\|/, $line);                
    if ($name ne "") {
     if ($reg ne 'yes') {$name1 =~ tr/([a-z-])/([A-Z-])/; }
     if (index ($name1,$name)>=0) { $found+=1; }
    }
    if ($day ne "") {
     if ($day1==$day) { $found+=1; }
    }
    if ($mon ne "") {
     if ($mon1==$mon) { $found+=1; }
    }
    if ($year ne "") {
     if ($year1==$year) { $found+=1; }
    }
    if ($comment ne "") {
     if ($reg ne 'yes') { $comment1 =~ tr/([a-z-])/([A-Z-])/; }
     if (index ($comment1,$comment)>=0) { $found+=1; }
    }
    if  ( (($mode eq "no") and ($found>0)) or 
          (($mode eq "yes") and ($found == $fields)) ) {
     print "<tr><td>$name1</td><td>$day1</td><td>$mon1</td><td>$year1</td><td>$comment1</td></tr>\n";
     $lines+=1;
    }
   }
   print "</table><hr width=\"100%\" size=1 align=center noshade>\n";
   $all=$#data+1;
   print "<i> : $lines<br>  : $all<br>\n";
   print "   : ";
   if ($reg ne 'yes') {    print "";   }
   else {    print "";   }
   print "</i>";
  }
 }
 else {
  print "  $basename .   ,   <a href=\"$myname?action=admin\">  </a> .     <a href=\"$hisname\"></a>      .";
 }
 &htmlend;
 exit;
}

sub printdate {
 print <<DATE1;
   : 
<select name=day size=1>
<option selected value=""></option>
<option value=01>01</option>
<option value=02>02</option>
<option value=03>03</option>
<option value=04>04</option>
<option value=05>05</option>
<option value=06>06</option>
<option value=07>07</option>
<option value=08>08</option>
<option value=09>09</option>
<option value=10>10</option>
<option value=11>11</option>
<option value=12>12</option>
<option value=13>13</option>
<option value=14>14</option>
<option value=15>15</option>
<option value=16>16</option>
<option value=17>17</option>
<option value=18>18</option>
<option value=19>19</option>
<option value=20>20</option>
<option value=21>21</option>
<option value=22>22</option>
<option value=23>23</option>
<option value=24>24</option>
<option value=25>25</option>
<option value=26>26</option>
<option value=27>27</option>
<option value=28>28</option>
<option value=29>29</option>
<option value=30>30</option>
<option value=31>31</option>
</select>
   : 
<select name=mon size=1>
<option selected value=""></option>
<option value=01></option>
<option value=02></option>
<option value=03></option>
<option value=04></option>
<option value=05></option>
<option value=06></option>
<option value=07></option>
<option value=08></option>
<option value=09></option>
<option value=10></option>
<option value=11></option>
<option value=12></option>
</select>
   : <select name=year size=1>
<option selected value=""></option>  
DATE1
 ($sec,$min,$hour,$mday,$mon1,$thisyear,$wday) = localtime(time); 
 if ($thisyear<1900) { $thisyear+=1900; }
 for ($i=$thisyear; $i>=1900; $i-=1) {
  print "<option value=$i>$i</option>\n";
 }
 print "</select>";
}

sub filter0 { #    
 $name=@_[0];
 $name =~ s/\|/\!/g;
 $name =~ s/\"/\'/g;
 $name =~ s/\</\[/g;
 $name =~ s/\>/\]/g;
 return $name;
}

sub filter1 { #   HTML
 $name=@_[0];
 $name =~ s/\|/!/g;
 $name =~ s/\<\/body\>//g;
 $name =~ s/\<\/html\>//g;
 return $name;
}

sub searchform {
print "<br>     (   -     ):";
print "<form method=get>";
print "<input type=hidden name=action value=show>";
print ": <input type=text name=name size=40 maxlength=40><br>";
&printdate;
print <<SEARCHFORM2;
 <br>: <input type=text size=40 maxlength=40 name=comment><br>
   <input type=radio name=mode value=yes checked>    <br>
   <input type=radio name=mode value=no>      <br>
          ? <input type=radio name=reg value=yes>  <input type=radio checked name=reg value=no> <br>
   <input type=submit class=button value=""> <input type=reset class=button value="">
  </form>
SEARCHFORM2
 print "<small>[<a href=\"$hisname\">&nbsp;&nbsp;&nbsp;</a>] ";
 print "[<a href=\"$myname?action=admin\">&nbsp;(&nbsp;)</a>]</small>";
}

sub search {
 @months = ('','','','','','','','','','','','','');
 &html;
 ($sec,$min,$hour,$day,$mon,$year,$wday) = localtime(time); 
 if ($year<1900) { $year+=1900; } 
 $mon+=1;
 print "<a href=\"$myname?action=show&day=$day&mon=$mon&mode=yes\">   ? ($day $months[$mon])</a>";
 &searchform;
 &htmlend;
 exit; 
}

sub plus {
 &html;
 $name=$FORM{'name'};
 $day=$FORM{'day'};
 $mon=$FORM{'mon'};
 $year=$FORM{'year'};
 $comment=$FORM{'comment'};
 $name0=&filter0 ($name);
 $comment0=&filter1 ($comment);
 $bad=0;
 if ($name0 eq "") {
  print "<p>  -        !</p>";
  $bad=1;
 }
 if ($day eq "") {
  print "<p>  -    !</p>";
  $bad=1;
 }
 if ($mon eq "") {
  print "<p>  -    !</p>";
  $bad=1;
 }
 if ($bad==0) {
  $added=0;
  open(DATA, "$datafolder/$basename");
  @data = <DATA>;
  close(DATA);
  open(DATA, ">$datafolder/$basename");
  foreach $line(@data) {
   chomp $line;
   ($name1, $day1, $mon1, $year1, $comment1) = split(/\|/, $line);
   if ($added ==0) {
    if ($mon <= $mon1) {
     if ($day <= $day1) {
      if ( ($name0 lt $name1) or
           (($mon==$mon1) and ($day<$day1)) ) {
       $newline=join "\|",$name0,$day,$mon,$year,$comment0;
       print DATA "$newline\n";
       $added=1;
      }
     }
    }
   }
   print DATA "$line\n";
  }
  if ($added==1) {
   print "<p> </p>";
  }
  else {
   print "<p>    </p>";
   $newline=join "\|",$name0,$day,$mon,$year,$comment0;
   print DATA "$newline\n";
  }
  close (DATA);
  &addform;
 }
 else {
  print "<br><a href=\"$myname?action=admin\">  \"\"    ...</a>";
 }
 &htmlend;
 exit;
}

sub delme {
 &html;
 $number=$FORM{'number'};
 if ($number ne "") {
  open(DATA, "$datafolder/$basename");
  @data = <DATA>;
  close(DATA);
  if (@data) {
   open(DATA, ">$datafolder/$basename");
   $count=0;
   foreach $line(@data) {
    chomp($line);
    if ($count!=$number) {
     print DATA "$line\n";
    }
    $count+=1;
   }
   close (DATA);
  }
 }
 &addform;
 &htmlend;
 exit;
}

sub addform {
 print "<br>[<a href=\"$myname?action=show\">  </a>]";
 print "<br>  :";
 print "<form method=post>";
 print "<input type=hidden name=action value=plus>";
 print ": <input type=text name=name size=40 maxlength=96><br>";
 &printdate;
 print <<ADDFORM;
   <br>: <input type=text size=40 maxlength=255 name=comment><br>
   <small>  "", ""  ""</small><br>
   <small><i>   <b></b>   <font color=red>|</font> (  <font color=red>!</font>).<br> 
   <b></b>   <font color=red>&lt;</font>, <font color=red>&gt;</font>, <font color=red>&quot;</font><br>
 <b></b>    ,   , !</font></i></small>
   <br><input type=submit class=button value=""> <input type=reset class=button value="">
  </form>
ADDFORM
 open(DATA, "$datafolder/$basename");
 @data = <DATA>;
 close(DATA);
 if (@data) {
  print "<table width=\"100%\" border=0>\n";
  print "<tr><td><b>!</b></td><td><b></b></td><td><b></b></td><td><b></b></td><td><b></b></td><td><b></b></td></tr>\n";
  $number=0;
  foreach $line(@data) {
   chomp($line);
   ($name1, $day1, $mon1, $year1, $comment1) = split(/\|/, $line);
   print "<tr><td><form method=post><input type=hidden name=action value=delme><input type=submit class=button name=number value=$number></form></td>";
   print "<td>$name1</td><td>$day1</td><td>$mon1</td><td>$year1</td><td>$comment1</td></tr>\n";
   $number+=1;
  } 
  print "</table>";
 }
 else {
  print "<br>   $basename    .";
 }
}

sub add {
 &checkpassword; 
 &html;
 &addform;
 &htmlend;
 exit;
}

sub admin {
 &html;
 print <<ADMINFORM;
  <br>     :
  <form method=get>
   <input type=hidden name=action value=add>
   <input type=password name=password size=10 maxlength=10>
   <input type=submit class=button value="">
  </form>
ADMINFORM
 &htmlend;
 exit;
}

sub html {
 open (HEADER,"$filehdr");
 while (<HEADER>) {
  print "$_";
 }
 close (HEADER); 
}

sub htmlend {
 open (SOF,"$fileend");
 while (<SOF>) {
  print "$_";
 }
 close (SOF); 
}		
